#!/bin/bash

read post
p="$(echo $post | tr '&' '\n')"
q="$(echo $QUERY_STRING | tr '&' '\n')"

src="$(echo "$q" | grep "^src=.*$" | cut -d '=' -f 2)"
src="$(if test "$src" = ""; then echo "/docker-step2021team01-web/cgi-bin/pruefungsplaner/index.sh"; else echo "$src"; fi)"
user="$(echo "$p" | grep "^user=.*$" | cut -d '=' -f 2)"
password="$(echo "$p" | grep "^password=.*$" | cut -d '=' -f 2 | shasum | cut -d ' ' -f 1)"
fullname="$(echo "$p" | grep "^fullname=.*$" | cut -d '=' -f 2)"
loginreturn="$(/home/docker-step2021team01/pruefungsplaner/checkuser.sh "$user" "$password")"

if test -n "$fullname" -a "$loginreturn" = "2"
then
  /home/docker-step2021team01/pruefungsplaner/createuser.sh "$user" "$password" "$fullname"
fi

if test "$loginreturn" = "0"
then

 cookieid=$(pwgen -s 128 1)
 test -d /tmp/pruefungsplaner/ || mkdir -p /tmp/pruefungsplaner/
 echo "$cookieid $user $(date +'%s')" >> /tmp/pruefungsplaner/cookies.txt

  echo "Content-Type: text/html"
  echo "Set-Cookie: team01pruefungsplaner=$cookieid; SameSite=Lax"
  echo

echo "<!DOCTYPE html>
<html>
<head>
<meta http-equiv=\"Refresh\" content=\"0; URL=$src\">
</head>
</html>"

else

# ---------------------------------------------------------------------------------

echo "Content-Type: text/html"
echo

echo '<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <title>Home | Prüfungsplan</title>
    <link rel="stylesheet" type="text/CSS" href="/step2021team01/style.css">
    <link rel="icon" type="image/svg" href="/step2021team01/pic/favicon.svg">
  </head>

  <body>
    <div class="header clearfix">
      <a href="#"><img class="logo" src="/step2021team01/pic/TeamIGEL.svg"></a>
      <h1>Team IGEL</h1>
      <h2>Informatiker googlen einfache Lösungen</h2>

    </div>
    <div class="row clearfix">
      <div class="menu">
        <div class="field">
          <h1>Navigation</h1>
          <div class="navbar">
            <a href="/step2021team01">Home</a>
            <a href="team.html">Team-Mitglieder</a>
            <a href="/docker-step2021team01-web/cgi-bin/pegelstaendesystem/index.sh">STEP-Projekt</a>
            <a href="#" class="active">SWE-Prototyp</a>
          </div>
        </div>
        <div class="field" style="position: sticky; top: 0;">
          <a href="login.html" class="button">Anmelden</a><br>
        </div>
      </div>
      <div class="content">
        <div class="field3">
          <div class="field">
            <h2>Anmelden</h2>'
            if test -n "$user" -a -z "$fullname"
then
  echo '<div style="border: 1px solid red; border-left: 10px solid red; width: 100%; text-align: left; margin: 10px 0; padding: 10px">Login nicht erfolgreich! <i>Achten Sie bitte auf Groß- Kleinschreibung beim Benutzernamen und Passwort</i>.</div>'
fi

echo '            <form method="post">
              <label for="user">Benutzername:</label>
              <input type="text" name="user" value="' 
              echo $user 
              echo '"><br>
              <label for="password">Passwort:</label>
              <input type="password" name="password"><br>
              <input type="submit" value="Anmelden">
            </form>
          </div>
        </div>
        <div class="field3">
          <div class="field">
            <h2>Registrieren</h2>'

if test -n "$user" -a -n "$fullname" -a "$loginreturn" != "2"
then
echo '<div style="border: 1px solid red; border-left: 10px solid red; width: 100%; text-align: left; margin: 10px 0; padding: 10px">Registrierung nicht erfolgreich!</div>'
elif test -n "$user" -a -n "$fullname" -a "$loginreturn" = "2"
then
  echo '<div style="border: 1px solid green; border-left: 10px solid green; width: 100%; text-align: left; margin: 10px 0; padding: 10px">Registrierung erfolgreich! Bitte links anmelden.</div>'  
fi

echo '            <form method="post">
              <label for="user">Benutzername:</label>
              <input type="text" name="user"><br>
              <label for="fullname">Voller Name:</label>
              <input type="text" name="fullname"><br>
              <label for="password">Passwort:</label>
              <input type="password" name="password"><br>
              <input type="submit" value="Registrieren">
            </form>
          </div>
        </div>
      </div>
    </div>
  </body>
</html>'

fi
